// Code generated by protoc-gen-go. DO NOT EDIT.
// source: rpc/actions.proto

package rpc

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import google_protobuf "github.com/golang/protobuf/ptypes/empty"
import _ "google.golang.org/genproto/googleapis/api/annotations"
import _ "github.com/grpc-ecosystem/grpc-gateway/protoc-gen-swagger/options"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

type ContactRequestOrResponse struct {
	Phone   *Phone   `protobuf:"bytes,1,opt,name=phone" json:"phone,omitempty"`
	Contact *Contact `protobuf:"bytes,2,opt,name=contact" json:"contact,omitempty"`
}

func (m *ContactRequestOrResponse) Reset()                    { *m = ContactRequestOrResponse{} }
func (m *ContactRequestOrResponse) String() string            { return proto.CompactTextString(m) }
func (*ContactRequestOrResponse) ProtoMessage()               {}
func (*ContactRequestOrResponse) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{0} }

func (m *ContactRequestOrResponse) GetPhone() *Phone {
	if m != nil {
		return m.Phone
	}
	return nil
}

func (m *ContactRequestOrResponse) GetContact() *Contact {
	if m != nil {
		return m.Contact
	}
	return nil
}

type BoolMessageReply struct {
	IsOk bool   `protobuf:"varint,1,opt,name=isOk" json:"isOk,omitempty"`
	Msg  string `protobuf:"bytes,2,opt,name=msg" json:"msg,omitempty"`
}

func (m *BoolMessageReply) Reset()                    { *m = BoolMessageReply{} }
func (m *BoolMessageReply) String() string            { return proto.CompactTextString(m) }
func (*BoolMessageReply) ProtoMessage()               {}
func (*BoolMessageReply) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{1} }

func (m *BoolMessageReply) GetIsOk() bool {
	if m != nil {
		return m.IsOk
	}
	return false
}

func (m *BoolMessageReply) GetMsg() string {
	if m != nil {
		return m.Msg
	}
	return ""
}

func init() {
	proto.RegisterType((*ContactRequestOrResponse)(nil), "rpc.ContactRequestOrResponse")
	proto.RegisterType((*BoolMessageReply)(nil), "rpc.BoolMessageReply")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for AddressBook service

type AddressBookClient interface {
	AddContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error)
	FindAll(ctx context.Context, in *google_protobuf.Empty, opts ...grpc.CallOption) (AddressBook_FindAllClient, error)
	FindByNumber(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*ContactRequestOrResponse, error)
	EditContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error)
	DeleteContact(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*BoolMessageReply, error)
}

type addressBookClient struct {
	cc *grpc.ClientConn
}

func NewAddressBookClient(cc *grpc.ClientConn) AddressBookClient {
	return &addressBookClient{cc}
}

func (c *addressBookClient) AddContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error) {
	out := new(BoolMessageReply)
	err := grpc.Invoke(ctx, "/rpc.AddressBook/AddContact", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *addressBookClient) FindAll(ctx context.Context, in *google_protobuf.Empty, opts ...grpc.CallOption) (AddressBook_FindAllClient, error) {
	stream, err := grpc.NewClientStream(ctx, &_AddressBook_serviceDesc.Streams[0], c.cc, "/rpc.AddressBook/FindAll", opts...)
	if err != nil {
		return nil, err
	}
	x := &addressBookFindAllClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type AddressBook_FindAllClient interface {
	Recv() (*ContactRequestOrResponse, error)
	grpc.ClientStream
}

type addressBookFindAllClient struct {
	grpc.ClientStream
}

func (x *addressBookFindAllClient) Recv() (*ContactRequestOrResponse, error) {
	m := new(ContactRequestOrResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *addressBookClient) FindByNumber(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*ContactRequestOrResponse, error) {
	out := new(ContactRequestOrResponse)
	err := grpc.Invoke(ctx, "/rpc.AddressBook/FindByNumber", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *addressBookClient) EditContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error) {
	out := new(BoolMessageReply)
	err := grpc.Invoke(ctx, "/rpc.AddressBook/EditContact", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *addressBookClient) DeleteContact(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*BoolMessageReply, error) {
	out := new(BoolMessageReply)
	err := grpc.Invoke(ctx, "/rpc.AddressBook/DeleteContact", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for AddressBook service

type AddressBookServer interface {
	AddContact(context.Context, *ContactRequestOrResponse) (*BoolMessageReply, error)
	FindAll(*google_protobuf.Empty, AddressBook_FindAllServer) error
	FindByNumber(context.Context, *Phone) (*ContactRequestOrResponse, error)
	EditContact(context.Context, *ContactRequestOrResponse) (*BoolMessageReply, error)
	DeleteContact(context.Context, *Phone) (*BoolMessageReply, error)
}

func RegisterAddressBookServer(s *grpc.Server, srv AddressBookServer) {
	s.RegisterService(&_AddressBook_serviceDesc, srv)
}

func _AddressBook_AddContact_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ContactRequestOrResponse)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).AddContact(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/rpc.AddressBook/AddContact",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).AddContact(ctx, req.(*ContactRequestOrResponse))
	}
	return interceptor(ctx, in, info, handler)
}

func _AddressBook_FindAll_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(google_protobuf.Empty)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(AddressBookServer).FindAll(m, &addressBookFindAllServer{stream})
}

type AddressBook_FindAllServer interface {
	Send(*ContactRequestOrResponse) error
	grpc.ServerStream
}

type addressBookFindAllServer struct {
	grpc.ServerStream
}

func (x *addressBookFindAllServer) Send(m *ContactRequestOrResponse) error {
	return x.ServerStream.SendMsg(m)
}

func _AddressBook_FindByNumber_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Phone)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).FindByNumber(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/rpc.AddressBook/FindByNumber",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).FindByNumber(ctx, req.(*Phone))
	}
	return interceptor(ctx, in, info, handler)
}

func _AddressBook_EditContact_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ContactRequestOrResponse)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).EditContact(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/rpc.AddressBook/EditContact",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).EditContact(ctx, req.(*ContactRequestOrResponse))
	}
	return interceptor(ctx, in, info, handler)
}

func _AddressBook_DeleteContact_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Phone)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).DeleteContact(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/rpc.AddressBook/DeleteContact",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).DeleteContact(ctx, req.(*Phone))
	}
	return interceptor(ctx, in, info, handler)
}

var _AddressBook_serviceDesc = grpc.ServiceDesc{
	ServiceName: "rpc.AddressBook",
	HandlerType: (*AddressBookServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "AddContact",
			Handler:    _AddressBook_AddContact_Handler,
		},
		{
			MethodName: "FindByNumber",
			Handler:    _AddressBook_FindByNumber_Handler,
		},
		{
			MethodName: "EditContact",
			Handler:    _AddressBook_EditContact_Handler,
		},
		{
			MethodName: "DeleteContact",
			Handler:    _AddressBook_DeleteContact_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "FindAll",
			Handler:       _AddressBook_FindAll_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "rpc/actions.proto",
}

func init() { proto.RegisterFile("rpc/actions.proto", fileDescriptor1) }

var fileDescriptor1 = []byte{
	// 801 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x94, 0xcf, 0x8f, 0xdc, 0x34,
	0x14, 0xc7, 0xe5, 0x5d, 0x68, 0xc1, 0xdb, 0xaa, 0x8b, 0x4b, 0x97, 0x55, 0xd4, 0x8a, 0xc7, 0x14,
	0xa1, 0x32, 0x74, 0x93, 0x32, 0x7b, 0x41, 0x73, 0xcb, 0x2e, 0xed, 0x05, 0x41, 0x57, 0xb3, 0x48,
	0x88, 0x03, 0x3f, 0x9c, 0xe4, 0x4d, 0xc6, 0xd4, 0xb1, 0x8d, 0xed, 0x74, 0x19, 0x55, 0xbd, 0x80,
	0x38, 0x23, 0x0d, 0x12, 0x07, 0x04, 0x08, 0xf1, 0xe7, 0x70, 0xe0, 0xc2, 0xbf, 0xc0, 0xdf, 0x81,
	0x50, 0x9c, 0x64, 0x98, 0xd9, 0x1f, 0x70, 0xe8, 0x65, 0x26, 0x79, 0x7e, 0x7e, 0xdf, 0x8f, 0xbf,
	0x79, 0x7e, 0xf4, 0x25, 0x6b, 0xf2, 0x84, 0xe7, 0x5e, 0x68, 0xe5, 0x62, 0x63, 0xb5, 0xd7, 0x6c,
	0xd3, 0x9a, 0x3c, 0xda, 0x6e, 0xe2, 0x95, 0x2e, 0x50, 0x76, 0xe1, 0x68, 0xbf, 0x14, 0x7e, 0x56,
	0x67, 0x71, 0xae, 0xab, 0xa4, 0xd4, 0x92, 0xab, 0x32, 0x09, 0x0b, 0x59, 0x3d, 0x4d, 0x8c, 0x9f,
	0x1b, 0x74, 0x09, 0x56, 0xc6, 0xcf, 0xdb, 0xdf, 0x6e, 0xd3, 0xcd, 0x52, 0xeb, 0x52, 0x62, 0xc2,
	0x8d, 0x48, 0xb8, 0x52, 0xda, 0xf3, 0x15, 0xa5, 0xe8, 0x6e, 0xf8, 0xcb, 0xf7, 0x4a, 0x54, 0x7b,
	0xee, 0x84, 0x97, 0x25, 0xda, 0x44, 0x9b, 0x90, 0x71, 0x36, 0x7b, 0xf0, 0xed, 0x06, 0xdd, 0x3d,
	0xd4, 0xca, 0xf3, 0xdc, 0x4f, 0xf0, 0xcb, 0x1a, 0x9d, 0x7f, 0x68, 0x27, 0xe8, 0x8c, 0x56, 0x0e,
	0x19, 0xd0, 0xe7, 0xcd, 0x4c, 0x2b, 0xdc, 0x25, 0x40, 0xee, 0x6c, 0x8d, 0x68, 0x6c, 0x4d, 0x1e,
	0x1f, 0x35, 0x91, 0x49, 0xbb, 0xc0, 0xde, 0xa0, 0x97, 0xf3, 0x76, 0xf7, 0xee, 0x46, 0xc8, 0xb9,
	0x12, 0x72, 0xfa, 0x8a, 0xfd, 0xe2, 0xf8, 0x17, 0xb2, 0x48, 0x7f, 0x24, 0xf4, 0x68, 0x78, 0xeb,
	0x22, 0xb1, 0xe3, 0x19, 0x56, 0x38, 0x7a, 0xe5, 0x0b, 0xa7, 0xd5, 0x67, 0x2e, 0x9f, 0x61, 0xc5,
	0xa1, 0x40, 0x97, 0x5b, 0x11, 0xd0, 0xc7, 0x3b, 0x4f, 0xa0, 0x42, 0xe7, 0x78, 0x89, 0x63, 0x18,
	0x14, 0x38, 0xe5, 0xb5, 0xf4, 0x03, 0x78, 0x3a, 0x7c, 0x40, 0x6f, 0x3f, 0x10, 0xaa, 0x00, 0x5d,
	0x7b, 0xa8, 0xb4, 0x45, 0xe0, 0x59, 0xf3, 0xb8, 0x54, 0xe9, 0x4e, 0xf2, 0xea, 0xcc, 0x7b, 0x33,
	0x4e, 0x92, 0x8b, 0xd4, 0x07, 0xef, 0xd0, 0xed, 0x03, 0xad, 0xe5, 0xfb, 0xad, 0xc6, 0x04, 0x8d,
	0x9c, 0x33, 0x46, 0x9f, 0x13, 0xee, 0xe1, 0xa3, 0x70, 0xfa, 0x17, 0x26, 0xe1, 0x99, 0x6d, 0xd3,
	0xcd, 0xca, 0x95, 0xe1, 0xb0, 0x2f, 0x4e, 0x9a, 0xc7, 0xd1, 0xdf, 0x97, 0xe8, 0x56, 0x5a, 0x14,
	0x16, 0x9d, 0x3b, 0xd0, 0xfa, 0x11, 0xfb, 0x8d, 0x50, 0x9a, 0x16, 0x45, 0xa7, 0xc4, 0x6e, 0xad,
	0x19, 0x72, 0x5a, 0x37, 0xba, 0x11, 0x96, 0x4f, 0x4b, 0x0f, 0x3e, 0x5d, 0xa4, 0x87, 0x8c, 0xfd,
	0x5b, 0x06, 0x5c, 0x5d, 0x55, 0xdc, 0xce, 0xa3, 0xbd, 0x43, 0x8b, 0xdc, 0xa3, 0x03, 0x85, 0x27,
	0xd0, 0xb9, 0x0b, 0x5c, 0x15, 0xc0, 0x8b, 0xc2, 0x81, 0xf0, 0x20, 0x94, 0xd7, 0x50, 0x70, 0xcf,
	0x33, 0xee, 0xf0, 0xeb, 0x3f, 0xff, 0xfa, 0x7e, 0x83, 0x0d, 0xae, 0x26, 0x4d, 0xe3, 0x75, 0xd9,
	0x6e, 0x4c, 0x86, 0xec, 0x3b, 0x42, 0x2f, 0x37, 0xbe, 0xa5, 0x52, 0xb2, 0x9d, 0xb8, 0xed, 0xa7,
	0xb8, 0xef, 0xbc, 0xf8, 0x7e, 0xd3, 0x6c, 0xd1, 0x7f, 0x93, 0x0f, 0xde, 0x5b, 0xa4, 0xfb, 0xec,
	0x5a, 0x57, 0x64, 0xc9, 0x07, 0xc7, 0x33, 0x7d, 0xe2, 0x80, 0x4b, 0xd9, 0xd3, 0x39, 0x98, 0x5a,
	0x5d, 0xad, 0x23, 0x5d, 0x63, 0xeb, 0x48, 0xf7, 0x08, 0xfb, 0x99, 0xd0, 0x2b, 0x4d, 0xb1, 0x83,
	0xf9, 0x07, 0x75, 0x95, 0xa1, 0x65, 0x2b, 0xdd, 0xf6, 0x7f, 0x28, 0xd9, 0x22, 0x4d, 0xd9, 0xcb,
	0xab, 0xbb, 0x97, 0x3c, 0x6f, 0x36, 0x51, 0x17, 0x1c, 0xb2, 0xe8, 0x6b, 0xab, 0xdc, 0xd2, 0xb5,
	0x6c, 0x0e, 0xa1, 0x89, 0x41, 0x85, 0x2d, 0x01, 0x6c, 0x97, 0xed, 0xac, 0x81, 0x25, 0x4f, 0xda,
	0xc5, 0xa7, 0xec, 0x27, 0x42, 0xb7, 0xee, 0x17, 0xc2, 0x3f, 0xdb, 0x77, 0xfd, 0x68, 0x91, 0xee,
	0xb1, 0xeb, 0x2b, 0x75, 0x96, 0xa0, 0x3b, 0x4d, 0xd0, 0x01, 0x7e, 0x25, 0x9c, 0x17, 0xaa, 0xec,
	0x29, 0x03, 0xd5, 0x6b, 0xd1, 0xcd, 0x53, 0x54, 0x01, 0x3c, 0xee, 0xd8, 0x9a, 0x0f, 0xfa, 0x03,
	0xa1, 0x57, 0xdf, 0x45, 0x89, 0x1e, 0x7b, 0xc0, 0x55, 0xff, 0x2e, 0xa0, 0x09, 0xbe, 0xdd, 0x58,
	0xdb, 0xb6, 0xe4, 0xb9, 0xd3, 0x86, 0xcf, 0x12, 0x9d, 0xef, 0xdb, 0xf0, 0x02, 0xdf, 0xa2, 0xcf,
	0x17, 0xe9, 0x27, 0xac, 0xc5, 0x68, 0xae, 0x07, 0x78, 0x0d, 0xa1, 0xcf, 0xa0, 0x44, 0x9f, 0x4a,
	0xd9, 0xcb, 0xb6, 0x6d, 0xdd, 0xbd, 0x45, 0x6f, 0xd1, 0xd7, 0xcf, 0xbb, 0xd5, 0xcb, 0x2a, 0xc7,
	0x68, 0x1f, 0x8b, 0x1c, 0xd9, 0x66, 0x6d, 0xe5, 0xc1, 0x1f, 0x64, 0x91, 0xfe, 0x4e, 0xd8, 0xaf,
	0x84, 0x5e, 0x5f, 0xb9, 0x87, 0xd0, 0xe7, 0x7c, 0x43, 0x3e, 0x9c, 0x09, 0x07, 0xc2, 0x01, 0x07,
	0xc7, 0x2b, 0x23, 0x11, 0x1c, 0xda, 0xc7, 0x68, 0xe1, 0x08, 0xbd, 0xf3, 0x4d, 0xf5, 0xf6, 0x3d,
	0x86, 0x8f, 0x75, 0x0d, 0x39, 0x57, 0x30, 0x3d, 0x47, 0xfb, 0xb8, 0x1d, 0xa5, 0xc0, 0x3d, 0x74,
	0xb3, 0xa4, 0x1b, 0xae, 0xb1, 0xd0, 0xa0, 0x2d, 0x68, 0x05, 0xc2, 0xe6, 0xf1, 0xd4, 0x22, 0x2a,
	0x5d, 0x60, 0xac, 0xd0, 0xdf, 0x85, 0xdb, 0x7d, 0xce, 0x68, 0xf3, 0xed, 0xf8, 0xde, 0x90, 0x90,
	0xd1, 0x36, 0x37, 0x46, 0x8a, 0x3c, 0xcc, 0xe0, 0xa4, 0x19, 0x76, 0xe3, 0x33, 0x91, 0xec, 0x52,
	0x30, 0x68, 0xff, 0x9f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x7b, 0x7c, 0x66, 0xba, 0x47, 0x06, 0x00,
	0x00,
}
